module Fanli
  # Base class to inherit
  class Base
    def self.inherited(sub)
      sub.extend(ClassMethods)
    end

    def initialize(*args)
      @args = args
    end

    def perform
      throw(:please_create_your_own_perform_method)
    end

    # Class Methods
    module ClassMethods
      def for(*args)
        with(*args)
      end

      def to(*args)
        with(*args)
      end

      def with(*args)
        obj = new(*args)
        obj.perform
      end
    end
  end
end
